"""Test fftw spectrum computation
"""
from hysop.domain.box import Box
from hysop.fields.continuous_field import Field
from hysop.operator.spectrum import Spectrum
from hysop.tools.parameters import Discretization
from hysop.problem.simulation import Simulation
from hysop import testsenv
import numpy as np
pi = np.pi
sin = np.sin
cos = np.cos


def computeScal(res, x, y, z, t):
    """test function, scalar input, 3D"""
    res[0][...] = z * sin((3 * pi * x) * (2 * pi * y))
    return res


@testsenv.fftw_failed
def test_spectrum():
    """build/apply spectrum op
    """
    dom = Box()
    field = Field(domain=dom, name='Field',
                  is_vector=False, formula=computeScal)
    d3D = Discretization([257, 257, 257])

    op = Spectrum(field, discretization=d3D)
    op.discretize()
    op.setup()
    topo = op.discrete_fields[field].topology
    field.initialize(topo=topo)
    simu = Simulation(nb_iter=1)
    simu.initialize()
    op.apply(simu)
