
import sympy as sm

class ComplexMul(sm.Expr):
    """Tag for complex multiplication."""
    def __new__(cls, lhs, rhs, **kwds):
        obj = super(ComplexMul, cls).__new__(cls, lhs, rhs, **kwds)
        obj.lhs, obj.rhs = lhs, rhs
        return obj

    def __str__(self):
        return 'cmul({},{})'.format(self.lhs, self.rhs)
    
    def __repr__(self):
        return 'ComplexMul({},{})'.format(repr(self.lhs), repr(self.rhs))
    
    def _sympystr(self, printer):
        return 'cmul({},{})'.format(printer._print(self.lhs), printer._print(self.rhs))
